Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/CONFIG/makenemo
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/CONFIG/makenemo	(revision 10155)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/CONFIG/makenemo	(revision 10156)
@@ -360,4 +360,24 @@
     cd ${NEMO_TDIR}/${NEW_CONF} || cd -
 
+    #-
+    #- Get git version information if available
+    mkdir -p ${CONFIG_DIR}/${NEW_CONF}/BLD/inc
+    GITVERSIONHEADER=${CONFIG_DIR}/${NEW_CONF}/BLD/inc/gitversion.h90
+    echo "Extracting git commit info into" $GITVERSIONHEADER
+    NEMOCOMMIT=$( git describe --always --dirty )
+    if [ $? -ne 0 ]
+    then
+       echo "Unable to extract git commit info!"
+       NEMOCOMMIT="NOT AVAILABLE"
+    fi
+    echo "#define _NEMO_COMMIT_ID_ '${NEMOCOMMIT}'" > ${GITVERSIONHEADER}
+    NEMOBRANCH=$( git name-rev --name-only HEAD )
+    if [ $? -ne 0 ]
+    then
+       echo "Unable to extract git branch info!"
+       NEMOBRANCH="UNKNOWN"
+    fi
+    echo "#define _NEMO_BRANCH_ '${NEMOBRANCH}'" >> ${GITVERSIONHEADER}
+
 #if AGRIF we do a first preprocessing
     if [ ${#x_c} -eq 0 ]; then
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/inputs_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/inputs_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/inputs_fabm.F90	(revision 10156)
@@ -0,0 +1,254 @@
+MODULE inputs_fabm
+   !!======================================================================
+   !!                         ***  MODULE inputs_fabm  ***
+   !! TOP :   Input module of the FABM tracers
+   !!======================================================================
+
+#if defined key_fabm
+   !!----------------------------------------------------------------------
+   !!   'key_fabm'                                               FABM tracers
+   !!----------------------------------------------------------------------
+   !! initialize_inputs       : initialize input structures
+   !! update_inputs : update 2D input fields
+   !! trc_rnf_fabm : update river data
+   !!----------------------------------------------------------------------
+   USE par_trc
+   USE oce_trc
+   USE trc
+   USE iom
+   USE fldread
+   USE par_fabm
+   USE fabm
+
+   IMPLICIT NONE
+
+   PRIVATE
+
+   PUBLIC initialize_inputs
+   PUBLIC link_inputs
+   PUBLIC update_inputs
+   PUBLIC trc_rnf_fabm
+
+   #if defined key_trdtrc && defined key_iomput
+      REAL(wp), PUBLIC, ALLOCATABLE, SAVE, TARGET, DIMENSION(:,:,:) :: tr_inp
+   #endif
+
+   TYPE, PUBLIC :: type_input_variable
+      TYPE(FLD), ALLOCATABLE, DIMENSION(:) :: sf
+      INTEGER                              :: ntimes
+   END TYPE
+
+   TYPE, PUBLIC, EXTENDS(type_input_variable) :: type_input_data
+      TYPE(type_horizontal_variable_id)   :: horizontal_id
+      TYPE(type_input_data), POINTER   :: next => null()
+   END TYPE
+   TYPE (type_input_data), POINTER, PUBLIC :: first_input_data => NULL()
+
+   TYPE, PUBLIC, EXTENDS(type_input_variable):: type_river_data
+      INTEGER   :: jp_pos=0 ! position of linked state variable in trc fields
+      REAL(wp) :: rn_trrnfac=1._wp ! unit conversion factor
+      TYPE(type_river_data), POINTER   :: next => null()
+   END TYPE
+   TYPE (type_river_data), POINTER, PUBLIC :: first_river_data => NULL()
+
+   CONTAINS
+
+     SUBROUTINE initialize_inputs
+        TYPE(FLD_N)        :: sn, sn_empty
+        CHARACTER(LEN=256) :: name
+        REAL(wp) :: rfac
+        NAMELIST /variable/ name,sn
+        NAMELIST /riverdata/ name,sn,rfac
+        LOGICAL :: l_ext
+        INTEGER :: num, ierr, nmlunit
+        TYPE (type_input_data),POINTER :: input_data
+        TYPE (type_river_data),POINTER :: river_data
+        INTEGER :: jn
+        INTEGER , PARAMETER :: nbtimes = 366  !: maximum number of times record in a file
+        REAL(wp), DIMENSION(nbtimes) :: zsteps
+
+        ! Check if fabm_input.nml exists - if not, do nothing and return.
+        INQUIRE( FILE='fabm_input.nml', EXIST=l_ext )
+        IF (.NOT.l_ext) return
+
+        ! Open fabm_input.nml
+        CALL ctl_opn( nmlunit, 'fabm_input.nml', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, num, .FALSE. )
+
+        ! Read any number of "variable" namelists
+        DO
+           ! Initialize namelist variables
+           name = ''
+           sn = sn_empty
+
+           ! Read the namelist
+           READ(nmlunit,nml=variable,err=98,end=99)
+
+           ! Transfer namelist settings to new input_data object
+           ALLOCATE(input_data, STAT=ierr)
+           IF( ierr > 0 ) CALL ctl_stop( 'STOP', 'inputs_fabm:initialize_inputs: unable to allocate input_data object for variable '//TRIM(name) )
+           input_data%horizontal_id = fabm_get_horizontal_variable_id(model,name)
+           IF (.NOT.fabm_is_variable_used(input_data%horizontal_id)) THEN
+              ! This variable was not found among FABM's horizontal variables (at least, those that are read by one or more FABM modules)
+              CALL ctl_stop('STOP', 'inputs_fabm:initialize_inputs: variable "'//TRIM(name)//'" was not found among horizontal FABM variables.')
+           END IF
+           ALLOCATE(input_data%sf(1), STAT=ierr)
+           IF( ierr > 0 ) CALL ctl_stop( 'STOP', 'inputs_fabm:initialize_inputs: unable to allocate sf structure for variable '//TRIM(name) )
+           CALL fld_fill(input_data%sf, (/sn/), '', 'inputs_fabm:initialize_inputs', 'FABM variable '//TRIM(name), 'variable' )
+           ALLOCATE( input_data%sf(1)%fnow(jpi,jpj,1)   )
+           IF( sn%ln_tint ) ALLOCATE( input_data%sf(1)%fdta(jpi,jpj,1,2) )
+
+           ! Get number of record in file (if there is only one, we will read data
+           ! only at the very first time step)
+           CALL fld_clopn( input_data%sf(1) )
+           CALL iom_gettime( input_data%sf(1)%num, zsteps, kntime=input_data%ntimes)
+           CALL iom_close( input_data%sf(1)%num )
+
+           ! Prepend new input variable to list.
+           input_data%next => first_input_data
+           first_input_data => input_data
+        END DO
+
+  98    CALL ctl_stop('STOP', 'inputs_fabm:initialize_inputs: unable to read namelist "riverdata"')
+
+  99    REWIND(nmlunit)
+
+        ! Read any number of "riverdata" namelists
+        DO
+           ! Initialize namelist variables
+           name = ''
+           sn = sn_empty
+           rfac = 1._wp
+
+           ! Read the namelist
+           READ(nmlunit,nml=riverdata,err=198,end=199)
+
+           ! Transfer namelist settings to new river_data object
+           ALLOCATE(river_data, STAT=ierr)
+           IF( ierr > 0 ) CALL ctl_stop( 'STOP', 'inputs_fabm:initialize_inputs: unable to allocate river_data object for variable '//TRIM(name) )
+           ! Check if river data name is in FABM states and
+           ! provide NEMO with position of the respective state variable
+           ! within tracer field
+           DO jn=1,jp_fabm
+             IF (TRIM(name) == TRIM(model%state_variables(jn)%name)) THEN
+               river_data%jp_pos = jp_fabm_m1+jn
+             END IF
+           END DO
+           IF (river_data%jp_pos == 0) THEN
+             ! This variable was not found among FABM's state variables
+             ! passed to NEMO!
+             CALL ctl_stop('STOP', 'inputs_fabm:initialize_inputs: variable "'//TRIM(name)//'" was not found among FABM state variables.')
+           END IF
+
+           ALLOCATE(river_data%sf(1), STAT=ierr)
+           IF( ierr > 0 ) CALL ctl_stop( 'STOP', 'inputs_fabm:initialize_inputs: unable to allocate sf structure for variable '//TRIM(name) )
+           CALL fld_fill(river_data%sf, (/sn/), '', 'inputs_fabm:initialize_inputs', 'FABM variable '//TRIM(name), 'riverdata' )
+           ALLOCATE( river_data%sf(1)%fnow(jpi,jpj,1)   )
+           IF( sn%ln_tint ) ALLOCATE( river_data%sf(1)%fdta(jpi,jpj,1,2) )
+
+           ! Load unit conversion factor:
+           river_data%rn_trrnfac=rfac
+
+           ! Get number of record in file (if there is only one, we will read data
+           ! only at the very first time step)
+           CALL fld_clopn( river_data%sf(1) )
+           CALL iom_gettime( river_data%sf(1)%num, zsteps, kntime=river_data%ntimes)
+           CALL iom_close( river_data%sf(1)%num )
+
+           ! Prepend new input variable to list.
+           river_data%next => first_river_data
+           first_river_data => river_data
+        END DO
+
+  198   CALL ctl_stop('STOP', 'inputs_fabm:initialize_inputs: unable to read namelist "riverdata"')
+
+  199   RETURN
+
+     END SUBROUTINE initialize_inputs
+
+     SUBROUTINE link_inputs
+      TYPE (type_input_data),POINTER :: input_data
+
+      input_data => first_input_data
+      DO WHILE (ASSOCIATED(input_data))
+         ! Provide FABM with pointer to field that will receive prescribed data.
+         ! NB source=data_source_user guarantees that the prescribed data takes priority over any data FABM may already have for that variable.
+         CALL fabm_link_horizontal_data(model,input_data%horizontal_id,input_data%sf(1)%fnow(:,:,1),source=data_source_user)
+         input_data => input_data%next
+      END DO
+
+   END SUBROUTINE link_inputs
+
+   SUBROUTINE update_inputs( kt , l_write)
+      INTEGER, INTENT(IN) :: kt
+      LOGICAL, INTENT(IN), OPTIONAL :: l_write
+      TYPE (type_input_data),POINTER :: input_data
+      TYPE (type_river_data),POINTER :: river_data
+
+      input_data => first_input_data
+      DO WHILE (ASSOCIATED(input_data))
+         IF( kt == nit000 .OR. ( kt /= nit000 .AND. input_data%ntimes > 1 ) ) CALL fld_read( kt, 1, input_data%sf )
+#if defined key_trdtrc && defined key_iomput
+         IF ( .NOT.PRESENT(l_write).OR.l_write ) CALL iom_put( 'INP_'//TRIM(input_data%sf(1)%clvar), input_data%sf(1)%fnow(:,:,1)*tmask(:,:,1) )
+#endif
+         input_data => input_data%next
+      END DO
+
+      river_data => first_river_data
+      DO WHILE (ASSOCIATED(river_data))
+         IF( kt == nit000 .OR. ( kt /= nit000 .AND. river_data%ntimes > 1 ) ) CALL fld_read( kt, 1, river_data%sf )
+         river_data => river_data%next
+      END DO
+
+   END SUBROUTINE update_inputs
+
+   SUBROUTINE trc_rnf_fabm( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_rnf_fabm  ***
+      !!
+      !! ** Purpose :   Add river loadings of biogeochemistry to states
+      !!
+      !! ** Action  :   tra (sms) updated with loadings at time-step kt
+      !!
+      !! This routines assumes river loadings to be given in
+      !! state variable units * m3 / sec
+      !!--------------------------------------------------------------------
+
+      INTEGER, INTENT(in) ::   kt          ! ocean time step
+      REAL(wp) :: zcoef
+      INTEGER :: ji,jj,jk
+      !
+      TYPE (type_river_data),POINTER :: river_data
+
+      river_data => first_river_data
+      DO WHILE (ASSOCIATED(river_data))
+#if defined key_trdtrc && defined key_iomput
+        tr_inp = 0.0_wp
+#endif
+        IF( kt == nit000 .OR. ( kt /= nit000 ) ) THEN
+            DO jj = 1, jpj
+              DO ji = 1, jpi
+                ! convert units and divide by surface area
+                ! loading / cell volume * vertical fraction of riverload
+                ! dtrc / dt (river) = riverload / e1e2t / e3t * e3t * h_rnf
+                !                    = riverload / e1e2t / h_rnf
+                zcoef = river_data%rn_trrnfac / e1e2t(ji,jj) / h_rnf(ji,jj)
+                DO jk = 1,nk_rnf(ji,jj)
+                  ! Add river loadings
+                  tra(ji,jj,jk,river_data%jp_pos) = tra(ji,jj,jk,river_data%jp_pos) + river_data%sf(1)%fnow(ji,jj,1)*zcoef
+#if defined key_trdtrc && defined key_iomput
+                  tr_inp(ji,jj,jk) = river_data%sf(1)%fnow(ji,jj,1)*zcoef
+#endif
+                END DO
+              END DO
+            END DO
+#if defined key_trdtrc && defined key_iomput
+            CALL iom_put( 'INP_'//TRIM(river_data%sf(1)%clvar), tr_inp(:,:,:) )
+#endif
+        END IF
+        river_data => river_data%next
+      END DO
+
+   END SUBROUTINE trc_rnf_fabm
+#endif
+   !!======================================================================
+END MODULE inputs_fabm
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/par_fabm.F90	(revision 10156)
@@ -0,0 +1,27 @@
+MODULE par_fabm
+
+   USE fabm
+
+   IMPLICIT NONE
+
+   TYPE (type_model) :: model !FABM model instance
+
+   INTEGER, PUBLIC :: jp_fabm0, jp_fabm1, jp_fabm, &
+                      jp_fabm_surface, jp_fabm_bottom, &
+                      jp_fabm_m1
+
+#if defined key_fabm
+   !!---------------------------------------------------------------------
+   !!   'key_fabm'                     FABM tracers
+   !!---------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_fabm     = .TRUE.   !: FABM flag 
+   LOGICAL, PUBLIC, ALLOCATABLE, DIMENSION(:) ::   lk_rad_fabm !: FABM negativity correction flag array 
+#else
+   !!---------------------------------------------------------------------
+   !!   Default                           No user defined tracers (FABM)
+   !!---------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_fabm     = .FALSE.  !: FABM flag 
+#endif
+
+   !!======================================================================
+END MODULE par_fabm
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/st2D_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/st2D_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/st2D_fabm.F90	(revision 10156)
@@ -0,0 +1,27 @@
+MODULE st2D_fabm
+   !!======================================================================
+   !!                      ***  MODULE  trc  ***
+   !! Passive tracers   :  module for tracers defined
+   !!======================================================================
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   USE par_oce
+
+   IMPLICIT NONE
+   PUBLIC
+   !! passive tracers fields (before,now,after)
+   !! --------------------------------------------------
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)         ::  fabm_st2Dn           !: 2D state concentration for now time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)         ::  fabm_st2Da           !: 2D state concentration for next time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)         ::  fabm_st2Db           !: 2D state concentration for before time step
+#else
+   !!----------------------------------------------------------------------
+   !!  Empty module :                                     No passive tracer
+   !!----------------------------------------------------------------------
+#endif
+
+   !!======================================================================
+END MODULE st2d_fabm
+   
Index: /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90	(revision 10156)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_FABM/NEMOGCM/NEMO/TOP_SRC/FABM/trcini_fabm.F90	(revision 10156)
@@ -0,0 +1,327 @@
+MODULE trcini_fabm
+   !!======================================================================
+   !!                         ***  MODULE trcini_fabm  ***
+   !! TOP :   initialisation of the FABM tracers
+   !!======================================================================
+   !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) Original code
+   !!----------------------------------------------------------------------
+#if defined key_fabm
+   !!----------------------------------------------------------------------
+   !!   'key_fabm'                                               FABM tracers
+   !!----------------------------------------------------------------------
+   !! trc_ini_fabm   : FABM model initialisation
+   !!----------------------------------------------------------------------
+   USE par_trc         ! TOP parameters
+   USE oce_trc
+   USE trc
+   USE par_fabm
+   USE trcsms_fabm
+   USE fabm_config,ONLY: fabm_create_model_from_yaml_file
+   USE fabm,ONLY: type_external_variable, fabm_initialize_library
+   USE inputs_fabm,ONLY: initialize_inputs,link_inputs, &
+     type_input_variable,type_input_data,type_river_data, &
+     first_input_data,first_river_data
+#if defined key_git_version
+   USE fabm_version,ONLY: fabm_commit_id=>git_commit_id, &
+                          fabm_branch_name=>git_branch_name
+   USE fabm_types,ONLY: type_version,first_module_version
+#endif
+
+
+   IMPLICIT NONE
+   PRIVATE
+
+#if defined key_git_version
+#include "gitversion.h90"
+   CHARACTER(len=*),parameter :: git_commit_id = _NEMO_COMMIT_ID_
+   CHARACTER(len=*),parameter :: git_branch_name = _NEMO_BRANCH_
+#endif
+
+   PUBLIC   trc_ini_fabm   ! called by trcini.F90 module
+   PUBLIC   nemo_fabm_init
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE nemo_fabm_init()
+      INTEGER :: jn
+      INTEGER, PARAMETER :: xml_unit = 1979
+      TYPE (type_input_data),POINTER :: input_data
+      TYPE (type_river_data),POINTER :: river_data
+      CLASS (type_input_variable),POINTER :: input_pointer
+
+      ! Allow FABM to parse fabm.yaml. This ensures numbers of variables are known.
+      call fabm_create_model_from_yaml_file(model)
+
+      jp_fabm = size(model%state_variables)
+      jp_fabm_bottom = size(model%bottom_state_variables)
+      jp_fabm_surface = size(model%surface_state_variables)
+      jp_fabm0 = jptra + 1
+      jp_fabm1 = jptra + jp_fabm
+      jp_fabm_m1=jptra
+      jptra = jptra + jp_fabm
+      jpdia2d = jpdia2d + size(model%horizontal_diagnostic_variables)
+      jpdia3d = jpdia3d + size(model%diagnostic_variables)
+      jpdiabio = jpdiabio + jp_fabm
+
+      !Initialize input data structures.
+      call initialize_inputs
+
+      IF (lwp) THEN
+         ! write field_def_fabm.xml on lead process
+         OPEN(UNIT=xml_unit,FILE='field_def_fabm.xml',ACTION='WRITE',STATUS='REPLACE')
+
+         WRITE (xml_unit,1000) '<field_definition level="1" prec="4" operation="average" enabled=".TRUE." default_value="1.e20" >'
+
+         WRITE (xml_unit,1000) ' <field_group id="ptrc_T" grid_ref="grid_T_3D">'
+         DO jn=1,jp_fabm
+            CALL write_variable_xml(xml_unit,model%state_variables(jn))
+#if defined key_trdtrc
+            CALL write_trends_xml(xml_unit,model%state_variables(jn))
+#endif
+         END DO
+         WRITE (xml_unit,1000) ' </field_group>'
+
+         WRITE (xml_unit,1000) ' <field_group id="sf_T" grid_ref="grid_T_2D">'
+         DO jn=1,jp_fabm_surface
+            CALL write_variable_xml(xml_unit,model%surface_state_variables(jn))
+         END DO
+         DO jn=1,jp_fabm_bottom
+            CALL write_variable_xml(xml_unit,model%bottom_state_variables(jn))
+         END DO
+         WRITE (xml_unit,1000) ' </field_group>'
+
+         WRITE (xml_unit,1000) ' <field_group id="diad_T" grid_ref="grid_T_2D">'
+         DO jn=1,size(model%diagnostic_variables)
+            CALL write_variable_xml(xml_unit,model%diagnostic_variables(jn),3)
+         END DO
+         DO jn=1,size(model%horizontal_diagnostic_variables)
+            CALL write_variable_xml(xml_unit,model%horizontal_diagnostic_variables(jn))
+         END DO
+         WRITE (xml_unit,1000) ' </field_group>'
+
+         WRITE (xml_unit,1000) ' <field_group id="fabm_scalar" grid_ref="grid_0">'
+         DO jn=1,size(model%conserved_quantities)
+            CALL write_variable_xml(xml_unit,model%conserved_quantities(jn))
+         END DO
+         WRITE (xml_unit,1000) ' </field_group>'
+
+         WRITE (xml_unit,1000) ' <field_group id="fabm_input" grid_ref="grid_T_2D">'
+         input_data => first_input_data
+         DO WHILE (ASSOCIATED(input_data))
+           input_pointer => input_data
+           CALL write_input_xml(xml_unit,input_pointer)
+            input_data => input_data%next
+         END DO
+         river_data => first_river_data
+         DO WHILE (ASSOCIATED(river_data))
+           input_pointer => river_data
+           CALL write_input_xml(xml_unit,input_pointer,3)
+            river_data => river_data%next
+         END DO
+         WRITE (xml_unit,1000) ' </field_group>'
+
+         WRITE (xml_unit,1000) '</field_definition>'
+
+         CLOSE(xml_unit)
+      END IF
+      IF( lk_mpp )   CALL mppsync !Ensure field_def_fabm is ready.
+
+1000 FORMAT (A)
+
+   END SUBROUTINE nemo_fabm_init
+
+   SUBROUTINE write_variable_xml(xml_unit,variable,flag_grid_ref)
+      INTEGER,INTENT(IN) :: xml_unit
+      INTEGER,INTENT(IN),OPTIONAL :: flag_grid_ref
+      CLASS (type_external_variable),INTENT(IN) :: variable
+
+      CHARACTER(LEN=20) :: missing_value,string_dimensions
+      INTEGER :: number_dimensions
+
+      ! Check variable dimension for grid_ref specificaiton.
+      ! Default is to not specify the grid_ref in the field definition.
+      IF (present(flag_grid_ref)) THEN
+          number_dimensions=flag_grid_ref
+      ELSE
+          number_dimensions=-1 !default, don't specify grid_ref
+      ENDIF
+
+      WRITE (missing_value,'(E9.3)') variable%missing_value
+      WRITE (string_dimensions,'(I1)') number_dimensions
+      SELECT CASE (number_dimensions)
+      CASE (3)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//'" unit="'//TRIM(variable%units)//'" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_3D" />'
+      CASE (2)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//'" unit="'//TRIM(variable%units)//'" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_2D"/>'
+      CASE (0)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//'" unit="'//TRIM(variable%units)//'" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="1point"/>'
+      CASE (-1)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//'" unit="'//TRIM(variable%units)//'" default_value="'//TRIM(ADJUSTL(missing_value))//'" />'
+      CASE default
+         IF(lwp) WRITE(numout,*) ' trc_ini_fabm: Failing to initialise output of variable '//TRIM(variable%name)//': Output of '//TRIM(ADJUSTL(string_dimensions))//'-dimensional variables not supported!!!'
+      END SELECT
+
+   END SUBROUTINE write_variable_xml
+
+   SUBROUTINE write_trends_xml(xml_unit,variable,flag_grid_ref)
+      INTEGER,INTENT(IN) :: xml_unit
+      INTEGER,INTENT(IN),OPTIONAL :: flag_grid_ref
+      CLASS (type_external_variable),INTENT(IN) :: variable
+
+      INTEGER :: number_dimensions,i
+      CHARACTER(LEN=20) :: missing_value,string_dimensions
+#if defined key_tracer_budget
+      CHARACTER(LEN=3),DIMENSION(10),PARAMETER :: trd_tags = (/ &
+        'LDF','BBL','FOR','ZDF','DMP','SMS','ATF', &
+        'RDB','RDN','VMV' /)
+      CHARACTER(LEN=3),DIMENSION(3),PARAMETER :: trd_e3t_tags = (/ &
+        'XAD','YAD','ZAD' /)
+#else
+      CHARACTER(LEN=3),DIMENSION(13),PARAMETER :: trd_tags = (/ &
+        'XAD','YAD','ZAD','LDF','BBL','FOR','ZDF','DMP','SMS','ATF', &
+        'RDB','RDN','VMV' /)
+#endif
+
+      ! Check variable dimension for grid_ref specificaiton.
+      ! Default is to not specify the grid_ref in the field definition.
+      IF (present(flag_grid_ref)) THEN
+          number_dimensions=flag_grid_ref
+      ELSE
+          number_dimensions=-1 !default, don't specify grid_ref
+      ENDIF
+
+      WRITE (missing_value,'(E9.3)') -2.E20
+      WRITE (string_dimensions,'(I1)') number_dimensions
+      SELECT CASE (number_dimensions)
+      CASE (3)
+        DO i=1,size(trd_tags)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(trd_tags(i))//'_'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//' '//TRIM(trd_tags(i))//' trend" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_3D" />'
+        END DO
+#if defined key_tracer_budget
+        DO i=1,size(trd_e3t_tags)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(trd_e3t_tags(i))//'_'//TRIM(variable%name)//'_e3t" long_name="'//TRIM(variable%long_name)//' cell depth integrated '//TRIM(trd_e3t_tags(i))//' trend" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_3D" />'
+        END DO
+        WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'_e3t" long_name="'//TRIM(variable%long_name)//' cell depth integrated" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_3D" />'
+#endif
+      CASE (-1)
+        DO i=1,size(trd_tags)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(trd_tags(i))//'_'//TRIM(variable%name)//'" long_name="'//TRIM(variable%long_name)//' '//TRIM(trd_tags(i))//' trend" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" />'
+        END DO
+#if defined key_tracer_budget
+        DO i=1,size(trd_e3t_tags)
+         WRITE (xml_unit,'(A)') '  <field id="'//TRIM(trd_e3t_tags(i))//'_'//TRIM(variable%name)//'_e3t" long_name="'//TRIM(variable%long_name)//' cell depth integrated '//TRIM(trd_e3t_tags(i))//' trend" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" />'
+        END DO
+        WRITE (xml_unit,'(A)') '  <field id="'//TRIM(variable%name)//'_e3t" long_name="'//TRIM(variable%long_name)//' cell depth integrated" unit="'//TRIM(variable%units)//'/s" default_value="'//TRIM(ADJUSTL(missing_value))//'" />'
+#endif
+      CASE default
+         IF(lwp) WRITE(numout,*) ' trc_ini_fabm: Failing to initialise trends of variable '//TRIM(variable%name)//': Output of '//TRIM(ADJUSTL(string_dimensions))//'-dimensional trends not supported!!!'
+      END SELECT
+
+   END SUBROUTINE write_trends_xml
+
+   SUBROUTINE write_input_xml(xml_unit,variable,flag_grid_ref)
+      INTEGER,INTENT(IN) :: xml_unit
+      INTEGER,INTENT(IN),OPTIONAL :: flag_grid_ref
+      CLASS(type_input_variable),POINTER,INTENT(IN) :: variable
+
+      INTEGER :: number_dimensions,i
+      CHARACTER(LEN=20) :: missing_value,string_dimensions
+
+      ! Check variable dimension for grid_ref specificaiton.
+      ! Default is to not specify the grid_ref in the field definition.
+      IF (present(flag_grid_ref)) THEN
+          number_dimensions=flag_grid_ref
+      ELSE
+          number_dimensions=-1 !default, don't specify grid_ref
+      ENDIF
+
+      WRITE (missing_value,'(E9.3)') -2.E20
+      WRITE (string_dimensions,'(I1)') number_dimensions
+      SELECT CASE (number_dimensions)
+      CASE (3)
+        WRITE (xml_unit,'(A)') '  <field id="'//'INP_'//TRIM(variable%sf(1)%clvar)//'" long_name="'//TRIM(variable%sf(1)%clvar)//' input" unit="" default_value="'//TRIM(ADJUSTL(missing_value))//'" grid_ref="grid_T_3D" />'
+      CASE (-1)
+        WRITE (xml_unit,'(A)') '  <field id="'//'INP_'//TRIM(variable%sf(1)%clvar)//'" long_name="'//TRIM(variable%sf(1)%clvar)//' input" unit="" default_value="'//TRIM(ADJUSTL(missing_value))//'" />'
+      CASE default
+         IF(lwp) WRITE(numout,*) ' trc_ini_fabm: Failing to initialise input diagnostic of variable '//TRIM(variable%sf(1)%clvar)//': Output of '//TRIM(ADJUSTL(string_dimensions))//'-dimensional diagnostic not supported!!!'
+      END SELECT
+
+   END SUBROUTINE write_input_xml
+
+   SUBROUTINE trc_ini_fabm
+      !!----------------------------------------------------------------------
+      !!                     ***  trc_ini_fabm  ***
+      !!
+      !! ** Purpose :   initialization for FABM model
+      !!
+      !! ** Method  : - Read the namcfc namelist and check the parameter values
+      !!----------------------------------------------------------------------
+#if defined key_git_version
+      TYPE (type_version),POINTER :: version
+#endif
+      INTEGER :: jn
+
+      !                       ! Allocate FABM arrays
+      IF( trc_sms_fabm_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_fabm: unable to allocate FABM arrays' )
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' trc_ini_fabm: initialisation of FABM model'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+#if defined key_git_version
+      IF(lwp) WRITE(numout,*) ' NEMO version:   ',git_commit_id,' (',git_branch_name,' branch)'
+      IF(lwp) WRITE(numout,*) ' FABM version:   ',fabm_commit_id,' (',fabm_branch_name,' branch)'
+#endif
+
+      call fabm_initialize_library()
+#if defined key_git_version
+      version => first_module_version
+
+      do while (associated(version))
+         IF(lwp) WRITE(numout,*)  ' '//trim(version%module_name)//' version:   ',trim(version%version_string)
+         version => version%next
+      end do
+#endif
+
+      ! Log mapping of FABM states:
+      IF (lwp) THEN
+         IF (jp_fabm.gt.0) WRITE(numout,*) " FABM tracers:"
+         DO jn=1,jp_fabm
+            WRITE(numout,*) "   State",jn,":",trim(model%state_variables(jn)%name), &
+               " (",trim(model%state_variables(jn)%long_name), &
+               ") [",trim(model%state_variables(jn)%units),"]"
+         ENDDO
+         IF (jp_fabm_surface.gt.0) WRITE(numout,*) "FABM seasurface states:"
+         DO jn=1,jp_fabm_surface
+            WRITE(numout,*) "   State",jn,":",trim(model%surface_state_variables(jn)%name), &
+               " (",trim(model%surface_state_variables(jn)%long_name), &
+               ") [",trim(model%surface_state_variables(jn)%units),"]"
+         ENDDO
+         IF (jp_fabm_bottom.gt.0) WRITE(numout,*) "FABM seafloor states:"
+         DO jn=1,jp_fabm_bottom
+            WRITE(numout,*) "   State",jn,":",trim(model%bottom_state_variables(jn)%name), &
+               " (",trim(model%bottom_state_variables(jn)%long_name), &
+               ") [",trim(model%bottom_state_variables(jn)%units),"]"
+         ENDDO
+      ENDIF
+
+   END SUBROUTINE trc_ini_fabm
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Dummy module                                        No FABM model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE nemo_fabm_init
+   END SUBROUTINE nemo_fabm_init
+
+   SUBROUTINE trc_ini_fabm            ! Empty routine
+   END SUBROUTINE trc_ini_fabm
+#endif
+
+   !!======================================================================
+END MODULE trcini_fabm
